# XMPP Implementation

## Storage

[XEP-0049] Private XML Storage will not be supported, as it provides an ability to store an arbitrary XML which cannot be reused by other projections. [XEP-0048] Bookmarks also will not be supported, as it relies on storage. Instead, potentially [XEP-0402] PEP Native Bookmarks will be implemented.

[XEP-0048]: https://xmpp.org/extensions/xep-0048.html
[XEP-0049]: https://xmpp.org/extensions/xep-0049.html
[XEP-0402]: https://xmpp.org/extensions/xep-0402.html

IQ namespace to be ignored is `jabber:iq:private`.

## Blocklists

[XEP-0016] will not be supported, as it's deprecated in favor of [XEP-0191], which potentially will be implemented.

[XEP-0016]: https://xmpp.org/extensions/xep-0016.html
[XEP-0191]: https://xmpp.org/extensions/xep-0191.html

IQ namespace to be ignored is `jabber:iq:privacy`.

## Chat history

[XEP-0313] Message Archive Management will be supported. Its implementation shall use the same storage backend as chat history features in other projections.

[XEP-0313]: https://xmpp.org/extensions/xep-0313.html

## Rooms

[XEP-0045] MUC and [XEP-0369] MIX will both be implemented. 

[XEP-0045]: https://xmpp.org/extensions/xep-0045.html
[XEP-0369]: https://xmpp.org/extensions/xep-0369.html